; --------------------------------
;
;  Macros
;
; --------------------------------
ST_busy equ $e2

pixel_do        macro
        movem.l d0-d1/a0,-(a7)

	lea	LCD_MEM,a0

        move.w  4*4+2(a7),d0            ; y-coordinate
	cmp.w	#128,d0
	bcc	\pixel_bad
	lsl.w	#1,d0
	move.w	d0,d1
	lsl.w	#4,d0
	sub.w	d1,d0
	lea	0(a0,d0.w),a0

        move.w  4*4+0(a7),d0            ; x-coordinate
	cmp.w	#240,d0
	bcc	\pixel_bad
	move.w	d0,d1
	lsr.w	#3,d0

	not.w	d1
	and.w	#7,d1
	b\1.b	d1,0(a0,d0.w)

\pixel_bad:
        movem.l (a7)+,d0-d1/a0
		endm

;*****************************************************

flib::find_pixel
find_pixel:
        move.w  d1,-(a7)

	lea	LCD_MEM,a0

        move.w  (4+2)+2(a7),d0          ; y-coordinate
	cmp.w	#128,d0
	bcc	pixel_bad
	lsl.w	#1,d0
	move.w	d0,d1
	lsl.w	#4,d0
	sub.w	d1,d0
	lea	0(a0,d0.w),a0

        move.w  (4+2)+0(a7),d1          ; x-coordinate
	cmp.w	#240,d1
	bcc	pixel_bad
	move.w	d1,d0
	lsr.w	#3,d1
	lea	0(a0,d1.w),a0
	not.w	d0
	and.w	#7,d0

pixel_good:
        move.w  (a7)+,d1
	rts

pixel_bad:
	sub.l	a0,a0
	bra	pixel_good

;*****************************************************

flib::pixel_on
pixel_on:
	pixel_do	set
	rts

;*****************************************************

flib::pixel_off
pixel_off:
	pixel_do	clr
	rts

;*****************************************************

flib::pixel_chg
pixel_chg:
	pixel_do	chg
	rts

;WriteStr MACRO
; move.w  \3,-(a7)
; pea						 \4
; move.w  \2,-(a7)
; move.w  \1,-(a7)
; jsr	doorsos::DrawStrXY        ; call the DrawStrXY ROM function
; lea						 10(a7),a7
; ENDM

;WriteChar  MACRO
;						move.w	#$00FF,-(a7)
;						move.w	#$0000,-(a7)
;						move.w	#$00FF,-(a7)
;						move.w	\3,-(a7)
;						move.w	\2,-(a7)
;						move.w	\1,-(a7)
;						move.w	\4,-(a7)
;                        jsr	doorsos::DrawStrXY        ; call the DrawStrXY ROM function
;						lea 		14(a7),a7
;					 ENDM

;SetFont MACRO
; move.w  \1,-(a7)
; jsr tios::FontSetSys
; lea						 2(a7),a7
; ENDM